diff --git a/kc.c b/kc.c
index cc6fe04d..1e5d53de 100644
--- a/kc.c
+++ b/kc.c
@@ -19,8 +19,7 @@ Z I randomBits();
 // Z I wdss(K *a,FILE *f);
 
 I interrupted = 0;
-extern I scrLim;        // script load limit
-I scrLim=0;
+I scrLim = 0;           // script load limit
 
 Z void handle_SIGINT(int sig) { interrupted = 1; }
 
diff --git a/km.c b/km.c
index 43828dcb..34ade074 100644
--- a/km.c
+++ b/km.c
@@ -42,35 +42,55 @@ I OOM_CD(I g, ...) //out-of-memory count-decrement
 //Arthur says he doesn't use malloc or free. Andrei Moutchkine claims smallest unit is vm page (his truss says no malloc + add pages one at a time).
 //Arthur not using malloc is probably true. No strdup & related functions in binary's strings. Note: Skelton references "different allocator" not in \w report
 //This source would be improved by getting ridding of remaing malloc/calloc/realloc
-K cd(K a)
+K cd(K x)
 {
   #ifdef DEBUG
-  if(a && a->c <=0 ) { er(Tried to cd() already freed item) dd(tests) dd((L)a) dd(a->c) dd(a->t) dd(a->n) show(a); }
+  if(x && x->c <=0 ) { er(Tried to cd() already freed item) dd(tests) dd((L)x) dd(x->c) dd(x->t) dd(x->n) show(x); }
   #endif 
-  if(!a || --a->c) R a;
+
+  P(!x,0)
+  x->c -= 1;
+
+  SW(xt)
+  {
+    CSR(5,)
+    CS(0, DO(xn, cd(kK(x)[xn-i-1]))) //repool in reverse, attempt to maintain order
+  }
+
+  if(x->c > 0) R x;
+
   #ifdef DEBUG
-  DO(kreci, if(a==krec[i]){krec[i]=0; break; })
+  DO(kreci, if(x==krec[i]){krec[i]=0; break; })
   #endif 
 
-  SW(a->t)
+  SW(xt)
   {
-    CS(7, DO(-2+TYPE_SEVEN_SIZE,cd(kV(a)[2+i]))) //-4 special trick: don't recurse on V members. assumes sizeof S==K==V.  (don't free CONTEXT or DEPTH)
-    CSR(5,)
-    CS(0, DO(a->n, cd(kK(a)[a->n-i-1]))) //repool in reverse, attempt to maintain order
+    CS(7, DO(-2+TYPE_SEVEN_SIZE,cd(kV(x)[2+i]))) //-4 special trick: don't recurse on V members. assumes sizeof S==K==V.  (don't free CONTEXT or DEPTH)
   }
 
   #ifdef DEBUG
   if(0)R 0; //for viewing K that have been over-freed
   #endif
-  //assumes seven_type a->k is < PG
-  I o=((size_t)a)&(PG-1);//file-mapped? 1:
-  I k=sz(a->t,a->n), r=lsz(k);
+  //assumes seven_type x->k is < PG
+  I o=((size_t)x)&(PG-1);//file-mapped? 1:
+  I k=sz(xt,xn), r=lsz(k);
   //assert file-maps have sizeof(V)==o and unpooled blocks never do (reasonable)
-  if(sizeof(V)==o || r>KP_MAX)munmap(((V)a)-o,k+o); //(file-mapped or really big) do not go back into pool. 
-  else repool(a,r);
+  if(sizeof(V)==o || r>KP_MAX)munmap(((V)x)-o,k+o); //(file-mapped or really big) do not go back into pool. 
+  else repool(x,r);
   R 0;
 }
-K ci(K a){if(a)a->c++; R a;}
+
+K ci(K x)
+{
+  P(!x,0)
+  x->c++;
+  SW(xt)
+  {
+    CSR(5,)
+    CS(0, DO(xn, ci(kK(x)[i])))
+  }
+  R x;
+}
 
 I bp(I t) {SW(ABS(t)){CSR(1, R sizeof(I)) CSR(2, R sizeof(F)) CSR(3, R sizeof(C)) CD: R sizeof(V); } } //Default 0/+-4/5/6/7  (assumes sizeof(K)==sizeof(S)==...)
 I sz(I t,I n){R 3*sizeof(I)+(7==t?TYPE_SEVEN_SIZE:n)*bp(t)+(3==ABS(t));} //not recursive. assert sz() > 0:  Everything gets valid block for simplified munmap/(free)
diff --git a/kx.c b/kx.c
index 39408f1a..1ac79c94 100644
--- a/kx.c
+++ b/kx.c
@@ -15,10 +15,13 @@ Z K ex0(V *v,K k,I r);
 Z K ex2(V *v,K k);
 Z V ex_(V a,I r);
 
-__thread I fer=0; // Flag Early Return 
-__thread I fwh=0; // Flag While
-__thread I stk=0; // Stack counter
-__thread I proj=0; // Projection
+__thread I fer=0;  // Flag Early Return 
+__thread I fwh=0;  // Flag While
+__thread I stk=0;  // Stack counter
+__thread I proj=0; // Projection 
+__thread K prnt=0; // Parent of Subfunction 
+__thread I f1s=1;  // Flag 1 for Subfunctions
+__thread I f2s=0;  // Flag 2 for Subfunctions
 
 //TODO: for derived verbs like +/ you can add the sub-pieces in parallel
 Z K overDyad(K a, V *p, K b)
@@ -451,6 +454,13 @@ K vf_ex(V q, K g)
         kV(f)[CACHE_TREE]=tree;
       }
 
+      if(f2s && prnt && kV(prnt)[LOCALS] && kV(prnt)[CACHE_TREE]){
+        K j0=dot_monadic(kV(prnt)[LOCALS]); K j1=dot_monadic(kV(prnt)[CACHE_TREE]);
+        K j2=join(j0,j1); cd(kV(prnt)[CACHE_TREE]); kV(prnt)[CACHE_TREE]=dot_monadic(j2);
+        cd(j0); cd(j1); cd(j2); tree=kV(prnt)[CACHE_TREE]; 
+        cd(kV(prnt)[CACHE_WD]); kV(prnt)[CACHE_WD]=0; 
+      }
+
       DO(p->n,e=EVP(DI(tree,i)); cd(*e); *e=0; if(r && i<r->n) *e=ci(kK(r)[i]); if(!*e && j<g->n) *e=ci(kK(g)[j++])) //merge in: CONJ with function args
 
       if(!(fw=kV(f)[CACHE_WD]))
@@ -499,7 +509,9 @@ Z V ex_(V a, I r)//Expand wd()->7-0 types, expand and evaluate brackets
   R z;
 }
 
-K ex(K a){U(a); if(7==a->t)if(*(kW(a))>(V)DT_SIZE){K tmp=*(K*)*(kW(a)); if(7==tmp->t)if(6==tmp->n)fwh=1;} K z=ex_(&a,0); cd(a); fer=0; fwh=0; stk=0; proj=0; R z;} //Input is 7-0 type from wd()
+K ex(K a) {   //Input is (usually, but not always) 7-0 type from wd()
+  U(a); if(a->t==7 && kVC(a)>(K)DT_SIZE && 7==kVC(a)->t && 6==kVC(a)->n)fwh=1;
+  K z=ex_(&a,0); cd(a); fer=fwh=stk=proj=f2s=0; f1s=1; prnt=0; R z; }
 
 Z K ex0(V*v,K k,I r) //r: {0,1,2} -> {code, (code), [code]} Reverse execution/return multiple (paren not function or script) "list notation"  {4,5,6,7} -> {:,if,while,do}
 {
@@ -672,10 +684,30 @@ Z K ex2(V*v, K k)  //execute words --- all returns must be Ks. v: word list, k:
 
   if(bk(*v)) R *v;  // ; case
 
-  if(!v[1] && !k){ R ex_(*v,1); }  // n case
+  if(!v[1] && !k){  // n case
+    K z=ex_(*v,1);
+    if(z>(K)DT_SIZE && z->t==7 && z->n==3){
+      if(prnt && f1s && kV(z)[PARAMS] && kV(prnt)[CACHE_TREE] && !kV(z)[CACHE_TREE] && kK(z)[PARAMS]->n){
+        K j0=dot_monadic(kV(z)[PARAMS]); K j1=dot_monadic(kV(prnt)[CACHE_TREE]); 
+        K j2=join(j0,j1); kV(z)[CACHE_TREE]=dot_monadic(j2); cd(j0); cd(j1); cd(j2); 
+      } 
+      prnt=z; 
+    }
+    R z; 
+  }
+
   if(!v[1] && sva(*v)){ R vf_ex(*v,k);}  //TODO: (,/:) and (,\:) both valence 2  
-  //TODO: brackets may also appear as:     +/\/\[]    {x}/\/\[]    a/\/\[]    (!200)\\[10;20]   
-  if(bk(v[1])) R ex_(*v,1);
+  //TODO: brackets may also appear as:     +/\/\[]    {x}/\/\[]    a/\/\[]    (!200)\\[10;20]
+
+  if(bk(v[1])){
+    K z= ex_(*v,1);
+    if(prnt && z->t==7 && z->n==3 && kV(prnt)[CACHE_TREE] && kV(z)[LOCALS] && !kK(z)[LOCALS]->n){
+      K j0=dot_monadic(kV(prnt)[CACHE_TREE]); K j1=dot_monadic(kV(z)[LOCALS]); 
+      K j2=join(j0,j1); kV(z)[CACHE_TREE]=dot_monadic(j2);
+      cd(j0); cd(j1); cd(j2); f1s=0; prnt=z; 
+    }
+    R z; 
+  }
 
   if(!VA(*v) && (offsetColon == v[1] || (VA(v[1]) && offsetColon==v[2]) ) ) //Handle assignment
   {
@@ -728,7 +760,17 @@ Z K ex2(V*v, K k)  //execute words --- all returns must be Ks. v: word list, k:
   i=0; while(adverbClass(v[1+i])) i++; //ALT'Y: i=adverbClass(b)?i+1:0;
   t2=ex2(v+1+i,k); //oom. these cannot be placed into single function call b/c order of eval is unspecified
   t3=ex_(*v,1);
-    u=*v; //Fixes a bug, see above. Not thread-safe. Adding to LOCALS probably better
+  if(t3>(K)DT_SIZE && t3->t==7 && t3->n==3){
+    if(prnt && kV(prnt)[CACHE_TREE] && kV(prnt)[CACHE_WD]){
+      if(kK(prnt)[CACHE_TREE]->n && kK(prnt)[LOCALS]->n && !kK(t3)[LOCALS]->n) {
+        f2s=1;
+        cd(kK(t3)[CACHE_TREE]); kK(t3)[CACHE_TREE]=kK(prnt)[CACHE_TREE]; ci(kK(t3)[CACHE_TREE]);
+      }
+    }
+    prnt=t3; 
+  }
+
+  u=*v; //Fixes a bug, see above. Not thread-safe. Adding to LOCALS probably better
   *v=VA(t3)?t3:(V)&t3;
   e=dv_ex(0,v+i,t2); *v=u;
   cd(t2); if(!VA(t3)) cd(t3);
diff --git a/tests.c b/tests.c
index d3aa94a4..3f2e3078 100644
--- a/tests.c
+++ b/tests.c
@@ -57,7 +57,7 @@ I tc(S a, S b) //test comparison .  R 0,1,2
 
   fprintf(stderr,"Failed: Memory Leak - %s, %s \nAllocated K: %lld\nUnfreed K  : %lld\nLeak %%     : %f\n", a,b,kreci, c, c/(F)kreci);
   I j=-1;
-  DO(c, do j++; while(!krec[j] && j < kreci); if(j>=kreci) break; K k=krec[j]; if(k){O("c:%lld t:%lld n:%lld | k:%ld\n",k->c,k->t,k->n,(L)k); show(k);} )
+  DO(c, do j++; while(!krec[j] && j < kreci); if(j>=kreci) break; K k=krec[j]; if(k){O("c:%lld t:%lld n:%lld | k:%p\n",k->c,k->t,k->n,k); show(k);} )
   R 0;
 }
 
@@ -150,11 +150,47 @@ Z I tests02()
   TC(7, {a::[1;7];a} 0)
 
   //Subfunctions
-  TC(skip, 3, {b:3; g:{b}; b:4; g[]}0) //Subfunctions inherit constants
-  TC(123, {g:{b:1};b::123;g[]} 0;b)
-  TC(3, {b:3; {b:4} 0; b}0)
-  TC(3,{[a;b]{[c;d]c+d}[a;b]}[1;2])
-  TC(2,{[a;a]a+a}[1;9]) //oddly enough
+  TC( 3, {b:3; g:{b}; b:4; g[]}0)       // inheritance: same var in prnt&child  child res
+  TC( 4, {b:3; g:{b}; b:4; b}0)         // inheritance: same var in prnt&child  prnt res
+  TC(_n, {b:3; g:{a}; b:4; g[]}0)       // inheritance: diff var in prnt/child, child res
+  TC( 4, {b:3; g:{a}; b:4; b}0)         // inheritance: diff var in prnt/child, prnt res
+  TC( 1, {g:{b:1}; g[]}0)               // :: subf-asgn, no prnt-asgn
+  TC(12, {g:{b:1}; b::12; g[]}0;b)      // :: gl-asgn, gl-res (no prnt-asgn)
+  TC( 1, {g:{b:1}; b::12; g[]}0)        // :: gl-asgn, child-res (no prnt-asgn)
+  TC( 1, {g:{b:1}; c::12; g[]}0)        // :: gl-asgn, child-res (diff gl variable)
+  TC( 4, {g:{b:1}; b::12; b:4; b}0)     // :: gl-asgn, prnt-res (prnt-asgn after gl-asgn)
+  TC(_n, {g:{b:1}; b::12; b:4; b}0;b)   // :: gl-asgn, glbl-res (prnt-asgn after gl-asgn)
+  TC(12, {g:{b:1}; b::12; b}0)          // :: gl-asgn, prnt-res (no prnt-asgn)
+  TC(12, {g:{b:1}; b:4; b::12; b}0)     // :: gl-asgn, prnt-res (prnt-asgn before gl-asgn)
+  TC(_n, {g:{b:1}; b:4; b::12; b}0;b)   // :: gl-asgn, glbl-res (prnt-asgn before gl-asgn)
+  TC(12, b:3;{g:{b:1};b::12;g[]} 0;b)   // :: gl-asgn, pre-existing gl
+  TC( 1, {g:{b:1;b}; b:12; g[]}0)       // :  prnt-asgn, child res
+  TC( 3, {b:3; {b:4; b}0; b}0)          // :  prnt-asgn, prnt res
+  TC( 3, {[a;b]{[c;d]c+d}[a;b]}[1;2])   // 2 explicit bracket args
+  TC( 2, {[a;a]a+a}[1;9])               // oddly enough (no subfunction)
+  TC( 1 10, {a:10; {x,a}x}1)            // 1 implicit arg: x
+  TC( 1 2 10, {a:10;{x,y,a}[x;y]}[1;2]) // 2 implicit args x,y
+  TC( 7, {{x+y+z}[x;y;z]+1}[1;2;3])     // 3 implict args: x,y,z
+  TC( 8, {x+{b:3;g:{b};b:4;g[]}0}5)     // Depth-2 and inheritance
+  TC( 4, {x-{x+{b:3;g:{b};b:4;g[]}0}5}12)  // Depth-3 and inheritance
+  TC(3 5, {x+y,{x-{x+{b:3;g:{b};b:4;g[]}0}5}12}[1;2])  // Depth-4
+  TC( 9, {+/x,{x+y,4}[1;2]}1)           // 2-level implicit args
+  TC( 9, {+/x,{x+y,{x-{x+{b:3; g:{b}; b:4; g[]}0}5}12}[1;2]}1) // Depth-5
+  TC( 5, {+/x,{x+y,{x-{x+{b:3; g:{b}; b:4; :7; g[]}0}5}12}[1;2]}1) // early-return in level-5
+  TC( 7, {+/x,{x+y,{x-{x+{b:3; g:{b}; b:4; g[]}0}5}12}[1;2]; :7}1) // early-return in level-1
+  TC( 3, {{b:3; g:{b}; b:4; g[]}0}0)    // unbuffered double braces
+  TC( 4, {1+{b:3; g:{b}; b:4; g[]}0}0)  // buffered double braces 
+  TC( 8, {({b:3;g:{b};b:4;g[]}0) + {b:5;g:{b};b:6;g[]}0}0) //double independent subfuncs
+  TC( 3, b:9; {b:3;g:{b};b:4;g[]}0)     // pre-existing K-Tree entry
+  TC(25, {{+/x,{x+y,{x-{x+{b:3;g:{b};b:4;g[]}0}5}12}[1;2]}1 + {x+{b:3;g:{b};b:4;g[]}0}5 + {x-{x+{b:3;g:{b};b:4;g[]}0}5}12 + x}4)
+         // 4 stacks: depth-5, depth-2, depth-3, and implicit
+  TC(1 3 10 3 10, g:1; do[2;{a:10; g::g,{x,a}x}3]; g) // do[2;] loop with subfunction (implicit arg) 
+  TC( 7, f:{x+y+z}; g:f[1;;3]; {b:3; h:{b}; b:4; g[h[ ] ] }0) // projection and subfunction
+  TC( 3, {:[x<2;1;_f[x-1]*x]}/: 2 3 4; {b:3; g:{b}; b:4; g[]}0) // muti-statement combo test
+  TC(120, {b:3; g:{b}; a::{:[x<2; 1; _f[x-1]*x]}5; g[ ]}0; a) // embedded _f with atom-arg
+  TC(2 6 24, {b:3; g:{b}; a::{:[x<2; 1; _f[x-1]*x]}/:2 3 4; g[ ]}0; a) // embedded _f with list-arg
+  TC( 5, {x + {[a] a+a} y}[1;2])        // Leon Baum test
+  TC( 5, {[a;b] a + {x+x} b}[1;2])      // Leon Baum test-2
 
   //Error trap: {[a;b][c;d] a+b} -> parse error ; { {[a][b] }} -> parse error
   TC(.[*; (3;4); :], (0;12) )
